/* Fitxer: InterficieConstants.java
   Descripci: Exemple d'utilitzaci d'interfcie per agrupar-hi constants
   Autor: Isidre Guix
*/
interface DiesSetmana
{
   int DILLUNS = 1, DIMARTS=2, DIMECRES=3, DIJOUS=4;
   int DIVENDRES=5, DISSABTE=6, DIUMENGE=7;
   String [] NOMS_DIES = {"", "Dilluns", "Dimarts", "Dimecres", 
           "Dijous", "Divendres", "Dissabte", "Diumenge"};
}

class InterficieConstants implements DiesSetmana
{
   public static void main (String args[])
   {
      System.out.println ("Els dies de la setmana sn:");
      for (int i=1; i<=7; i++)
         System.out.println (i + " : " +NOMS_DIES[i]);
   }
}