/* Fitxer: Sobreescriptura.java
   Descripci: Exemplificaci de sobreescriptura de dades i mtodes
   Autor: Isidre Guix
*/

class A
{
   int d=10;
   
   void xxx()
   {
      System.out.println ("d en A = " + d);
   }
   
   void xxx(int x)
   {
      char aux;
      if (this instanceof C) aux='C';
      else if (this instanceof B) aux='B';
      else aux='A';
      System.out.println ("Sc xxx d'A aplicat sobre un objecte de la classe " + aux );
   }
}

class B extends A
{
   int d=20;

   void xxx()
   {
      System.out.println ("d en B = " + d);
      super.xxx();
   }
}

class C extends B
{
   int d=30;

   void xxx()
   {
      System.out.println ("d en C = " + d);
      super.xxx();
   }

   void visibilitat ()
   {
      System.out.println("Des del mtode \"visibilitat\" en C:");
      System.out.println ("d en C = " + d);
      System.out.println ("d en B = " + super.d);
   }   
   
   public static void main (String args[])
   {
      int aux;
      A oa = new A();
      A ob = new B();
      A oc = new C();
      ((C)oc).visibilitat();
      System.out.println("Crides al mtode xxx() existent a les tres classes:");
      oa.xxx();
      ob.xxx();
      oc.xxx();
      System.out.println("Crides al mtode xxx(int x) existent a les tres classes:");
      oa.xxx(0);
      ob.xxx(0);
      oc.xxx(0);
   }
}
