/* Fitxer: AlgorismesHash.java
   Descripci: Classe que cont algorismes genrics per a tcniques Hash
   Autor: Isidre Guix
*/
package utilitats;

public class AlgorismesHash
{
   /** 
      Mtode vlid per calcular el hashCode() en una classe en la que
      el mtode equals() es basa en la comparaci d'un subconjunt de
      dades de la classe.
      Cal invocar el mtode genericHash() passant com arguments la llista
      de hashCode() de les dades de la classe que intervenen en el mtode
      equals()
   */
   public static int genericHash(int... campsHash)
   {
      int resultat = 17;
      for (int hash : campsHash) 
      {
         resultat = 37 * resultat + hash;
      }
      return resultat;
   }
}
